/* Wrapper for __log1pl that handles setting errno.
   Copyright (C) 2015-2016 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, see
   <http://www.gnu.org/licenses/>.  */

#include <errno.h>
#include <math.h>
#include <math_private.h>

long double
__w_log1pl (long double x)
{
  if (__glibc_unlikely (islessequal (x, -1.0L)))
    {
      if (x == -1.0L)
	__set_errno (ERANGE);
      else
	__set_errno (EDOM);
    }

  return __log1pl (x);
}
weak_alias (__w_log1pl, log1pl)
